#ifndef __MODEL_H__
#define __MODEL_H__

typedef struct _Model * Model;

struct _Model {
  GSList * eqs_name_list, * vars_name_list, * conds_name_list, * eqs_list,
    * confs_list;
  unsigned int neqs, nvars, nconds, nconfs;
} ;

typedef struct _Equation * Equation;

struct _Equation {
  char * comm, * comp , * eq, * cond, * varf, * depc, * matched;
  GSList * vars;
  unsigned int nvars, positive;
} ;

Model alloc_and_init_model(void);
Equation alloc_and_init_equation(void);

int add_eq_in_equation(Equation , char *);
int add_var_in_equation(Equation, char *);
int add_varf_in_equation(Equation, char *);
int add_comm_in_equation(Equation, char *);
int add_comp_in_equation(Equation, char *);
int add_cond_in_equation(Equation, char *);

Equation is_eq_in_model(char *);

/* int del_var_in_equation(Equation, char *); */
/* int del_varf_in_equation(Equation, char *); */
/* int del_comm_in_equation(Equation, char *); */
/* int del_comp_in_equation(Equation, char *); */
/* int del_cond_in_equation(Equation, char *); */

/* void free_model(void); */
/* void free_equation(void); */

#endif /* __MODEL_H__ */
