#ifndef __GRAPHS_H__
#define __GRAPHS_H__

#define set_arc_capacity(a, c)  ((a)->capacity) = (c)
#define set_arc_flow(a, f)  ((a)->flow) = (f)

typedef struct _Node * Node;

struct _Node {
  char * name;
  Node pred;
  int delta;
} ;

typedef struct _Arc * Arc;

struct _Arc {
  Node start;
  Node end;
  int capacity;
  int flow;
  char label[1024];
} ;

typedef struct _Graph * Graph;

struct _Graph {
  GSList * nodes_list;
  GSList * arcs_list;
} ;

Node add_new_node_to_graph(char *, Graph);
Arc add_new_arc_to_graph(char *, char *, Graph);
Node is_node_in_graph(char *, Graph);
Arc is_arc_in_graph(char *, char *, Graph);
GSList * search_successors(GSList *, Graph, GSList *);

int debug_print_graph(Graph);
int debug_print_arc(Arc);
int debug_print_node(Node);

#endif /* __GRAPHS_H__ */

/*** Local Variables: ***/
/*** change-log-default-name: "../ChangeLog" ***/
/*** End: ***/
